// -*- c++ -*-
#ifndef DEMO_H
#define DEMO_H
#include <gtk--.h>
#include <gtkgl--/glarea.h>

#include <glib.h>
#include <GL/gl.h>
#include "lw.h"


class MWin : public Gtk_Window {
  Gtk_Label *label;
  Gtk_VBox *vbox;
  
  gint delete_event_impl(GdkEventAny *)
    {
      Gtk_Main::instance()->quit();
      return (0);
    }
  
public:
  // trackball
  float beginx,beginy;    /* last recorded mouse position */
  float   curquat[4];     /* current quaternion */
  float   lastquat[4];    /* last quaternion */

  Gtk_GLArea *glarea;
  lwObject *lw_object;

  MWin();
  gint button_press_event_impl(GdkEventButton *);
  gint motion_notify_event_impl(GdkEventMotion *);
  gint configure_event_impl(GdkEventConfigure *);

  GLfloat lw_object_radius(void);
  void lw_object_scale(GLfloat);

  lwObject *lw_get_object(void) const { return(lw_object);}
};

static gint draw_lwobject(MWin *mwin);

#endif // DEMO_H
